----------------------------------------------------------------------------------
-- Company: The Hong Kong Polytechnic University
-- Engineer: Alexandr Melnikov
-- 
-- Create Date:    17:46:32 08/18/2016 
-- Design Name: 
-- Module Name:    brgen - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created

-- Additional Comments: 
-- Baud Rate Generator, receives clock signal from the upper level module
-- (FuncGen) along with the Baud Rate Divisor and supplies back to the 
-- upper level module corresponding Baud Rate clock (Baud tick)
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity brgen is
	 generic ( M : integer); -- baud rate divisor
    Port ( clk100mhz : in  STD_LOGIC;
			  bclk : out  STD_LOGIC); -- Baud tick (to FuncGen)
end brgen;

architecture Behavioral of brgen is

signal bcount : integer range 0 to M-1 := 0;
signal newclk : std_logic := '0';

begin

	process (clk100mhz)
	begin
		if (rising_edge(clk100mhz)) then
			if (bcount < M-1) then
				bcount <= bcount +1;
				newclk <= '0';
			else
				bcount <= 0;
				newclk <= '1'; -- baud tick of 1 clk100mhz period duration
			end if;
		end if;
	end process;

bclk <= newclk;

end Behavioral;

